package de.bsvrz.buv.plugin.darstellung.editparts.tree;

import org.eclipse.gef.editparts.AbstractTreeEditPart;
import org.eclipse.jface.resource.ResourceManager;
import org.eclipse.swt.graphics.Image;

import de.bsvrz.buv.plugin.darstellung.util.DarstellungIcons;
import de.bsvrz.dav.daf.main.config.ConfigurationArea;
import de.bsvrz.dav.daf.main.config.MutableSet;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.dav.daf.main.config.SystemObjectType;

/**
 * Tree Edit Part fr ein Systemobjekt.
 * 
 * <p>
 * Unterscheidet zwischen Systemobjekt, Konfigurationsbereich, dynamische Menge
 * und Systemobjekt allgemein.
 * 
 * @author BitCtrl Systems GmbH, Falko Schumann.
 * @version $Id$
 */
public class SystemObjectTreeEditPart extends AbstractTreeEditPart {

	@Override
	protected String getText() {
		return getModel().toString();
	}

	@Override
	protected Image getImage() {
		final SystemObject so = (SystemObject) getModel();

		if (so instanceof SystemObjectType) {
			return getResourceManager().createImage(
					DarstellungIcons.CategorySystemObjektTyp
							.getImageDescriptor());
		} else if (so instanceof ConfigurationArea) {
			return getResourceManager().createImage(
					DarstellungIcons.CategoryKonfigurationsbereich
							.getImageDescriptor());
		} else if (so instanceof MutableSet) {
			return getResourceManager().createImage(
					DarstellungIcons.CategoryDynamischeMenge
							.getImageDescriptor());
		}

		return getResourceManager().createImage(
				DarstellungIcons.CategorySystemObjekt.getImageDescriptor());
	}

	private ResourceManager getResourceManager() {
		return getViewer().getResourceManager();
	}

}
