/**
 * Darstellungsobjekte
 * Copyright (C) 2010 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weienfelser Strae 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 *
 * $Id$
 */
package de.bsvrz.buv.plugin.darstellung.model;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.EMap;
import org.eclipse.emf.ecore.EObject;

import com.bitctrl.lib.eclipse.emf.eclipse.model.Named;
import com.bitctrl.lib.eclipse.emf.gef.model.Sized;

import de.bsvrz.buv.plugin.dobj.model.DoTyp;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.Netz;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Darstellung</b></em>'. <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.bsvrz.buv.plugin.darstellung.model.Darstellung#getDoTypen <em>Do Typen</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.darstellung.model.Darstellung#getEbenen <em>Ebenen</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.darstellung.model.Darstellung#getNetz <em>Netz</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.darstellung.model.Darstellung#getZoomSkalierung <em>Zoom Skalierung</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.darstellung.model.Darstellung#getZoomStufen <em>Zoom Stufen</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.darstellung.model.Darstellung#getProperties <em>Properties</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.bsvrz.buv.plugin.darstellung.model.DarstellungPackage#getDarstellung()
 * @model abstract="true"
 * @generated
 */
public interface Darstellung extends Named, Sized {
	/**
	 * Returns the value of the '<em><b>Do Typen</b></em>' containment reference list.
	 * The list contents are of type {@link de.bsvrz.buv.plugin.dobj.model.DoTyp}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Do Typen</em>' containment reference list
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Do Typen</em>' containment reference list.
	 * @see de.bsvrz.buv.plugin.darstellung.model.DarstellungPackage#getDarstellung_DoTypen()
	 * @model containment="true"
	 * @generated
	 */
	EList<DoTyp> getDoTypen();

	/**
	 * Returns the value of the '<em><b>Ebenen</b></em>' containment reference list.
	 * The list contents are of type {@link de.bsvrz.buv.plugin.darstellung.model.Ebene}.
	 * It is bidirectional and its opposite is '{@link de.bsvrz.buv.plugin.darstellung.model.Ebene#getDarstellung <em>Darstellung</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Ebenen</em>' containment reference list isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Ebenen</em>' containment reference list.
	 * @see de.bsvrz.buv.plugin.darstellung.model.DarstellungPackage#getDarstellung_Ebenen()
	 * @see de.bsvrz.buv.plugin.darstellung.model.Ebene#getDarstellung
	 * @model opposite="darstellung" containment="true" required="true"
	 * @generated
	 */
	EList<Ebene> getEbenen();

	/**
	 * Returns the value of the '<em><b>Netz</b></em>' attribute. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Netz</em>' attribute isn't clear, there really
	 * should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Netz</em>' attribute.
	 * @see #setNetz(Netz)
	 * @see de.bsvrz.buv.plugin.darstellung.model.DarstellungPackage#getDarstellung_Netz()
	 * @model dataType="com.bitctrl.lib.eclipse.emf.davbitctrl.model.Netz"
	 * @generated
	 */
	Netz getNetz();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.darstellung.model.Darstellung#getNetz <em>Netz</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Netz</em>' attribute.
	 * @see #getNetz()
	 * @generated
	 */
	void setNetz(Netz value);

	/**
	 * Returns the value of the '<em><b>Zoom Skalierung</b></em>' attribute.
	 * The default value is <code>"1.0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Zoom Skalierung</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Zoom Skalierung</em>' attribute.
	 * @see #setZoomSkalierung(double)
	 * @see de.bsvrz.buv.plugin.darstellung.model.DarstellungPackage#getDarstellung_ZoomSkalierung()
	 * @model default="1.0"
	 * @generated
	 */
	double getZoomSkalierung();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.darstellung.model.Darstellung#getZoomSkalierung <em>Zoom Skalierung</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @param value the new value of the '<em>Zoom Skalierung</em>' attribute.
	 * @see #getZoomSkalierung()
	 * @generated
	 */
	void setZoomSkalierung(double value);

	/**
	 * Returns the value of the '<em><b>Zoom Stufen</b></em>' attribute list.
	 * The list contents are of type {@link java.lang.Double}. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Zoom Stufen</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Zoom Stufen</em>' attribute list.
	 * @see de.bsvrz.buv.plugin.darstellung.model.DarstellungPackage#getDarstellung_ZoomStufen()
	 * @model required="true"
	 * @generated
	 */
	EList<Double> getZoomStufen();

	/**
	 * Returns the value of the '<em><b>Properties</b></em>' map.
	 * The key is of type {@link K},
	 * and the value is of type {@link V},
	 * <!-- begin-user-doc
	 * -->
	 * <p>
	 * If the meaning of the '<em>Properties</em>' reference isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Properties</em>' map.
	 * @see de.bsvrz.buv.plugin.darstellung.model.DarstellungPackage#getDarstellung_Properties()
	 * @model mapType="com.bitctrl.lib.eclipse.emf.eclipse.model.Tupel<K, V>"
	 * @generated
	 */
	EMap<EObject, EObject> getProperties();

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	Ebene createEbene();

} // Darstellung
