/**
 * Darstellungsobjekte
 * Copyright (C) 2010 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weienfelser Strae 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 *
 * $Id$
 */
package de.bsvrz.buv.plugin.darstellung.model.impl;

import java.util.Collection;

import org.eclipse.draw2d.geometry.Point;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import com.bitctrl.lib.eclipse.emf.eclipse.model.impl.NamedImpl;

import de.bsvrz.buv.plugin.darstellung.model.Darstellung;
import de.bsvrz.buv.plugin.darstellung.model.DarstellungPackage;
import de.bsvrz.buv.plugin.darstellung.model.Ebene;
import de.bsvrz.buv.plugin.dobj.model.DoModel;
import de.bsvrz.sys.funclib.bitctrl.modell.bitctrlallgemein.objekte.Bild;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Ebene</b></em>'.<!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.bsvrz.buv.plugin.darstellung.model.impl.EbeneImpl#isVisible <em>Visible</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.darstellung.model.impl.EbeneImpl#getDarstellung <em>Darstellung</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.darstellung.model.impl.EbeneImpl#getDoObjekte <em>Do Objekte</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.darstellung.model.impl.EbeneImpl#getHintergrund <em>Hintergrund</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.darstellung.model.impl.EbeneImpl#getHintergrundSkalierung <em>Hintergrund Skalierung</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.darstellung.model.impl.EbeneImpl#getHintergrundLocation <em>Hintergrund Location</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.darstellung.model.impl.EbeneImpl#isEditable <em>Editable</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class EbeneImpl extends NamedImpl implements Ebene {
	/**
	 * The default value of the '{@link #isVisible() <em>Visible</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #isVisible()
	 * @generated
	 * @ordered
	 */
	protected static final boolean VISIBLE_EDEFAULT = true;
	/**
	 * The cached value of the '{@link #isVisible() <em>Visible</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #isVisible()
	 * @generated
	 * @ordered
	 */
	protected boolean visible = VISIBLE_EDEFAULT;
	/**
	 * The cached value of the '{@link #getDoObjekte() <em>Do Objekte</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getDoObjekte()
	 * @generated
	 * @ordered
	 */
	protected EList<DoModel> doObjekte;

	/**
	 * The default value of the '{@link #getHintergrund() <em>Hintergrund</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getHintergrund()
	 * @generated
	 * @ordered
	 */
	protected static final Bild HINTERGRUND_EDEFAULT = null;
	/**
	 * The cached value of the '{@link #getHintergrund() <em>Hintergrund</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getHintergrund()
	 * @generated
	 * @ordered
	 */
	protected Bild hintergrund = HINTERGRUND_EDEFAULT;
	/**
	 * The default value of the '{@link #getHintergrundSkalierung() <em>Hintergrund Skalierung</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getHintergrundSkalierung()
	 * @generated
	 * @ordered
	 */
	protected static final double HINTERGRUND_SKALIERUNG_EDEFAULT = 1.0;
	/**
	 * The cached value of the '{@link #getHintergrundSkalierung() <em>Hintergrund Skalierung</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getHintergrundSkalierung()
	 * @generated
	 * @ordered
	 */
	protected double hintergrundSkalierung = HINTERGRUND_SKALIERUNG_EDEFAULT;
	/**
	 * The default value of the '{@link #getHintergrundLocation() <em>Hintergrund Location</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getHintergrundLocation()
	 * @generated
	 * @ordered
	 */
	protected static final Point HINTERGRUND_LOCATION_EDEFAULT = null;
	/**
	 * The cached value of the '{@link #getHintergrundLocation() <em>Hintergrund Location</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getHintergrundLocation()
	 * @generated
	 * @ordered
	 */
	protected Point hintergrundLocation = HINTERGRUND_LOCATION_EDEFAULT;

	/**
	 * The default value of the '{@link #isEditable() <em>Editable</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #isEditable()
	 * @generated
	 * @ordered
	 */
	protected static final boolean EDITABLE_EDEFAULT = false;
	/**
	 * The cached value of the '{@link #isEditable() <em>Editable</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #isEditable()
	 * @generated
	 * @ordered
	 */
	protected boolean editable = EDITABLE_EDEFAULT;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected EbeneImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return DarstellungPackage.Literals.EBENE;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isVisible() {
		return visible;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setVisible(boolean newVisible) {
		boolean oldVisible = visible;
		visible = newVisible;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					DarstellungPackage.EBENE__VISIBLE, oldVisible, visible));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Darstellung getDarstellung() {
		if (eContainerFeatureID() != DarstellungPackage.EBENE__DARSTELLUNG)
			return null;
		return (Darstellung) eContainer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDarstellung(Darstellung newDarstellung,
			NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newDarstellung,
				DarstellungPackage.EBENE__DARSTELLUNG, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setDarstellung(Darstellung newDarstellung) {
		if (newDarstellung != eInternalContainer()
				|| (eContainerFeatureID() != DarstellungPackage.EBENE__DARSTELLUNG && newDarstellung != null)) {
			if (EcoreUtil.isAncestor(this, newDarstellung))
				throw new IllegalArgumentException(
						"Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newDarstellung != null)
				msgs = ((InternalEObject) newDarstellung).eInverseAdd(this,
						DarstellungPackage.DARSTELLUNG__EBENEN,
						Darstellung.class, msgs);
			msgs = basicSetDarstellung(newDarstellung, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					DarstellungPackage.EBENE__DARSTELLUNG, newDarstellung,
					newDarstellung));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EList<DoModel> getDoObjekte() {
		if (doObjekte == null) {
			doObjekte = new EObjectContainmentEList<DoModel>(DoModel.class,
					this, DarstellungPackage.EBENE__DO_OBJEKTE);
		}
		return doObjekte;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Bild getHintergrund() {
		return hintergrund;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setHintergrund(Bild newHintergrund) {
		Bild oldHintergrund = hintergrund;
		hintergrund = newHintergrund;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					DarstellungPackage.EBENE__HINTERGRUND, oldHintergrund,
					hintergrund));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public double getHintergrundSkalierung() {
		return hintergrundSkalierung;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setHintergrundSkalierung(double newHintergrundSkalierung) {
		double oldHintergrundSkalierung = hintergrundSkalierung;
		hintergrundSkalierung = newHintergrundSkalierung;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					DarstellungPackage.EBENE__HINTERGRUND_SKALIERUNG,
					oldHintergrundSkalierung, hintergrundSkalierung));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Point getHintergrundLocation() {
		return hintergrundLocation;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setHintergrundLocation(Point newHintergrundLocation) {
		Point oldHintergrundLocation = hintergrundLocation;
		hintergrundLocation = newHintergrundLocation;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					DarstellungPackage.EBENE__HINTERGRUND_LOCATION,
					oldHintergrundLocation, hintergrundLocation));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isEditable() {
		return editable;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setEditable(boolean newEditable) {
		boolean oldEditable = editable;
		editable = newEditable;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					DarstellungPackage.EBENE__EDITABLE, oldEditable, editable));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case DarstellungPackage.EBENE__DARSTELLUNG:
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			return basicSetDarstellung((Darstellung) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case DarstellungPackage.EBENE__DARSTELLUNG:
			return basicSetDarstellung(null, msgs);
		case DarstellungPackage.EBENE__DO_OBJEKTE:
			return ((InternalEList<?>) getDoObjekte()).basicRemove(otherEnd,
					msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(
			NotificationChain msgs) {
		switch (eContainerFeatureID()) {
		case DarstellungPackage.EBENE__DARSTELLUNG:
			return eInternalContainer().eInverseRemove(this,
					DarstellungPackage.DARSTELLUNG__EBENEN, Darstellung.class,
					msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case DarstellungPackage.EBENE__VISIBLE:
			return isVisible();
		case DarstellungPackage.EBENE__DARSTELLUNG:
			return getDarstellung();
		case DarstellungPackage.EBENE__DO_OBJEKTE:
			return getDoObjekte();
		case DarstellungPackage.EBENE__HINTERGRUND:
			return getHintergrund();
		case DarstellungPackage.EBENE__HINTERGRUND_SKALIERUNG:
			return getHintergrundSkalierung();
		case DarstellungPackage.EBENE__HINTERGRUND_LOCATION:
			return getHintergrundLocation();
		case DarstellungPackage.EBENE__EDITABLE:
			return isEditable();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case DarstellungPackage.EBENE__VISIBLE:
			setVisible((Boolean) newValue);
			return;
		case DarstellungPackage.EBENE__DARSTELLUNG:
			setDarstellung((Darstellung) newValue);
			return;
		case DarstellungPackage.EBENE__DO_OBJEKTE:
			getDoObjekte().clear();
			getDoObjekte().addAll((Collection<? extends DoModel>) newValue);
			return;
		case DarstellungPackage.EBENE__HINTERGRUND:
			setHintergrund((Bild) newValue);
			return;
		case DarstellungPackage.EBENE__HINTERGRUND_SKALIERUNG:
			setHintergrundSkalierung((Double) newValue);
			return;
		case DarstellungPackage.EBENE__HINTERGRUND_LOCATION:
			setHintergrundLocation((Point) newValue);
			return;
		case DarstellungPackage.EBENE__EDITABLE:
			setEditable((Boolean) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case DarstellungPackage.EBENE__VISIBLE:
			setVisible(VISIBLE_EDEFAULT);
			return;
		case DarstellungPackage.EBENE__DARSTELLUNG:
			setDarstellung((Darstellung) null);
			return;
		case DarstellungPackage.EBENE__DO_OBJEKTE:
			getDoObjekte().clear();
			return;
		case DarstellungPackage.EBENE__HINTERGRUND:
			setHintergrund(HINTERGRUND_EDEFAULT);
			return;
		case DarstellungPackage.EBENE__HINTERGRUND_SKALIERUNG:
			setHintergrundSkalierung(HINTERGRUND_SKALIERUNG_EDEFAULT);
			return;
		case DarstellungPackage.EBENE__HINTERGRUND_LOCATION:
			setHintergrundLocation(HINTERGRUND_LOCATION_EDEFAULT);
			return;
		case DarstellungPackage.EBENE__EDITABLE:
			setEditable(EDITABLE_EDEFAULT);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case DarstellungPackage.EBENE__VISIBLE:
			return visible != VISIBLE_EDEFAULT;
		case DarstellungPackage.EBENE__DARSTELLUNG:
			return getDarstellung() != null;
		case DarstellungPackage.EBENE__DO_OBJEKTE:
			return doObjekte != null && !doObjekte.isEmpty();
		case DarstellungPackage.EBENE__HINTERGRUND:
			return HINTERGRUND_EDEFAULT == null ? hintergrund != null
					: !HINTERGRUND_EDEFAULT.equals(hintergrund);
		case DarstellungPackage.EBENE__HINTERGRUND_SKALIERUNG:
			return hintergrundSkalierung != HINTERGRUND_SKALIERUNG_EDEFAULT;
		case DarstellungPackage.EBENE__HINTERGRUND_LOCATION:
			return HINTERGRUND_LOCATION_EDEFAULT == null ? hintergrundLocation != null
					: !HINTERGRUND_LOCATION_EDEFAULT
							.equals(hintergrundLocation);
		case DarstellungPackage.EBENE__EDITABLE:
			return editable != EDITABLE_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (visible: ");
		result.append(visible);
		result.append(", hintergrund: ");
		result.append(hintergrund);
		result.append(", hintergrundSkalierung: ");
		result.append(hintergrundSkalierung);
		result.append(", hintergrundLocation: ");
		result.append(hintergrundLocation);
		result.append(", editable: ");
		result.append(editable);
		result.append(')');
		return result.toString();
	}

} // EbeneImpl
