/**
 * Darstellungsobjekte
 * Copyright (C) 2010 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weienfelser Strae 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 *
 * $Id$
 */
package de.bsvrz.buv.plugin.darstellung.model.util;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import com.bitctrl.lib.eclipse.emf.eclipse.model.Named;
import com.bitctrl.lib.eclipse.emf.gef.model.Sized;

import de.bsvrz.buv.plugin.darstellung.model.*;
import de.bsvrz.buv.plugin.darstellung.model.Ansicht;
import de.bsvrz.buv.plugin.darstellung.model.Ausschnitt;
import de.bsvrz.buv.plugin.darstellung.model.AutoEbene;
import de.bsvrz.buv.plugin.darstellung.model.Darstellung;
import de.bsvrz.buv.plugin.darstellung.model.DarstellungPackage;
import de.bsvrz.buv.plugin.darstellung.model.DarstellungsSpalte;
import de.bsvrz.buv.plugin.darstellung.model.Ebene;
import de.bsvrz.buv.plugin.darstellung.model.MassstaeblicheDarstellung;
import de.bsvrz.buv.plugin.darstellung.model.StilisierteDarstellung;

/**
 * <!-- begin-user-doc --> The <b>Switch</b> for the model's inheritance
 * hierarchy. It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object and proceeding up the
 * inheritance hierarchy until a non-null result is returned, which is the
 * result of the switch. <!-- end-user-doc -->
 * @see de.bsvrz.buv.plugin.darstellung.model.DarstellungPackage
 * @generated
 */
public class DarstellungSwitch<T> {
	/**
	 * The cached model package
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected static DarstellungPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	public DarstellungSwitch() {
		if (modelPackage == null) {
			modelPackage = DarstellungPackage.eINSTANCE;
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	public T doSwitch(EObject theEObject) {
		return doSwitch(theEObject.eClass(), theEObject);
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected T doSwitch(EClass theEClass, EObject theEObject) {
		if (theEClass.eContainer() == modelPackage) {
			return doSwitch(theEClass.getClassifierID(), theEObject);
		} else {
			List<EClass> eSuperTypes = theEClass.getESuperTypes();
			return eSuperTypes.isEmpty() ? defaultCase(theEObject) : doSwitch(
					eSuperTypes.get(0), theEObject);
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
		case DarstellungPackage.DARSTELLUNG: {
			Darstellung darstellung = (Darstellung) theEObject;
			T result = caseDarstellung(darstellung);
			if (result == null)
				result = caseNamed(darstellung);
			if (result == null)
				result = caseSized(darstellung);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case DarstellungPackage.ANSICHT: {
			Ansicht ansicht = (Ansicht) theEObject;
			T result = caseAnsicht(ansicht);
			if (result == null)
				result = caseNamed(ansicht);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case DarstellungPackage.STILISIERTE_DARSTELLUNG: {
			StilisierteDarstellung stilisierteDarstellung = (StilisierteDarstellung) theEObject;
			T result = caseStilisierteDarstellung(stilisierteDarstellung);
			if (result == null)
				result = caseDarstellung(stilisierteDarstellung);
			if (result == null)
				result = caseNamed(stilisierteDarstellung);
			if (result == null)
				result = caseSized(stilisierteDarstellung);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case DarstellungPackage.MASSSTAEBLICHE_DARSTELLUNG: {
			MassstaeblicheDarstellung massstaeblicheDarstellung = (MassstaeblicheDarstellung) theEObject;
			T result = caseMassstaeblicheDarstellung(massstaeblicheDarstellung);
			if (result == null)
				result = caseDarstellung(massstaeblicheDarstellung);
			if (result == null)
				result = caseNamed(massstaeblicheDarstellung);
			if (result == null)
				result = caseSized(massstaeblicheDarstellung);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case DarstellungPackage.EBENE: {
			Ebene ebene = (Ebene) theEObject;
			T result = caseEbene(ebene);
			if (result == null)
				result = caseNamed(ebene);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case DarstellungPackage.DARSTELLUNGS_SPALTE: {
			DarstellungsSpalte darstellungsSpalte = (DarstellungsSpalte) theEObject;
			T result = caseDarstellungsSpalte(darstellungsSpalte);
			if (result == null)
				result = caseNamed(darstellungsSpalte);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case DarstellungPackage.AUTO_EBENE: {
			AutoEbene autoEbene = (AutoEbene) theEObject;
			T result = caseAutoEbene(autoEbene);
			if (result == null)
				result = caseEbene(autoEbene);
			if (result == null)
				result = caseNamed(autoEbene);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case DarstellungPackage.AUSSCHNITT: {
			Ausschnitt ausschnitt = (Ausschnitt) theEObject;
			T result = caseAusschnitt(ausschnitt);
			if (result == null)
				result = caseNamed(ausschnitt);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		default:
			return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Darstellung</em>'.
	 * <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Darstellung</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseDarstellung(Darstellung object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Ansicht</em>'.
	 * <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Ansicht</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAnsicht(Ansicht object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Stilisierte Darstellung</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Stilisierte Darstellung</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseStilisierteDarstellung(StilisierteDarstellung object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Massstaebliche Darstellung</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Massstaebliche Darstellung</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMassstaeblicheDarstellung(MassstaeblicheDarstellung object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Named</em>'.
	 * <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Named</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNamed(Named object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Sized</em>'.
	 * <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Sized</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSized(Sized object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Ebene</em>'.
	 * <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Ebene</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEbene(Ebene object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Darstellungs Spalte</em>'.
	 * <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Darstellungs Spalte</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseDarstellungsSpalte(DarstellungsSpalte object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Auto Ebene</em>'.
	 * <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Auto Ebene</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAutoEbene(AutoEbene object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Ausschnitt</em>'.
	 * <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Ausschnitt</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAusschnitt(Ausschnitt object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch, but this is
	 * the last case anyway. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	public T defaultCase(EObject object) {
		return null;
	}

} // DarstellungSwitch
