package de.bsvrz.buv.plugin.darstellung.util;

import org.eclipse.jface.resource.ImageDescriptor;

import de.bsvrz.buv.plugin.dobj.internal.DObjPlugin;

/**
 * Stellt gemeinsam nutzbare Icons zur Verfgung.
 * 
 * @author BitCtrl Systems GmbH, Schumann
 * @version $Id$
 */
public enum DarstellungIcons {

	// Icons fr Actions (actions)

	/** Schaltflche zum Anlegen eines neuen Ausschnitts. */
	ActionAusschnittAnlegen("icons/16x16/actions/ausschnitt-anlegen.png"),

	/** Schaltflche zum Synchronisieren der Selection von Workbench Parts. */
	ActionSelectionLink("icons/16x16/actions/selection-link.gif"),

	/** Schaltflche zum Ein-/Ausblenden des Ebenenmanagers. */
	ActionToggleEbenen("icons/16x16/actions/toggle-ebenen.gif"),

	/** Schaltflche zum Ein-/Ausblenden der bersicht. */
	ActionToggleOverview("icons/16x16/actions/toggle-overview.gif"),

	/** Schaltflche zum Whlen eines Ausschnitss. */
	ActionSelectAusschnitt("icons/16x16/actions/ausschnitt-waehlen.png"),

	/**
	 * Schaltflche zum Ausfhren der globalen Aktion zum Anpassen der
	 * Ansichten.
	 */
	ActionEditAnsichten("icons/16x16/actions/ansichten-edit.png"),

	/** Schaltflche fr den Selektionsfilter. */
	ActionSelectionFilter("icons/16x16/actions/selection-filter.gif"),

	/** Schaltflche fr den Selektionsfilter. */
	ActionEditEbene("icons/16x16/actions/ebene-edit.png"),

	// Icons fr Kategorien (categories)

	/** Icon fr einen Systemobjekttyp. */
	CategorySystemObjektTyp("icons/16x16/categories/systemobjekttyp.png"),

	/** Icon fr einen Konfigurationsbereich. */
	CategoryKonfigurationsbereich(
			"icons/16x16/categories/konfigurationsbereich.png"),

	/** Icon fr eine dynamische Menge. */
	CategoryDynamischeMenge("icons/16x16/categories/dynamischemenge.png"),

	/** Icon fr ein Systemobjekt. */
	CategorySystemObjekt("icons/16x16/categories/systemobjekt.png"),

	// Icons fr Statuswerte (status)

	/** Status fr eine sichtare Ebene. */
	StatusEbeneVisible("icons/16x16/status/ebene-visible.gif"),

	/** Status fr eine ausgeblendete Ebene. */
	StatusEbeneInvisible("icons/16x16/status/ebene-invisible.gif"),

	// Icons fr Objekt(typen)

	/** Typ-Icon fr <em>Ansicht</em>. */
	Ansicht("icons/full/obj16/Ansicht.gif"),

	/** Typ-Icon fr <em>Ansicht</em>. */
	Ausschnitt("icons/full/obj16/Ausschnitt.gif"),

	/** Typ-Icon fr <em>Ansicht</em>. */
	StilisierteDarstellung("icons/full/obj16/StilisierteDarstellung.gif"),

	/** Typ-Icon fr <em>Ansicht</em>. */
	MassstaeblicheDarstellung("icons/full/obj16/MassstaeblicheDarstellung.gif"),

	/** Typ-Icon fr <em>Ansicht</em>. */
	Ebene("icons/full/obj16/Ebene.gif"),

	/** Typ-Icon fr <em>Ansicht</em>. */
	DarstellungsSpalte("icons/full/obj16/DarstellungsSpalte.gif"),

	;

	private final ImageDescriptor imageDescriptor;

	private DarstellungIcons(final String imagePath) {
		imageDescriptor = DObjPlugin.getDefault().getImageDescriptor(imagePath);
		if (imageDescriptor == null) {
			final String message = "Datei nicht gefunden: " + imagePath;
			DObjPlugin.getDefault().getLogger().error(message);
		}
	}

	/**
	 * Gibt den {@link ImageDescriptor} zurck.
	 */
	public ImageDescriptor getImageDescriptor() {
		return imageDescriptor;
	}

}
