package de.bsvrz.buv.plugin.darstellung.wizards;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.jface.wizard.Wizard;

/**
 * Implementiert die gemeinsamen Eigenschaften von Import- und Export-Wizards.
 * 
 * @author BitCtrl Systems GmbH, Falko Schumann
 * @version $Id$
 */
public abstract class AbstractWizard extends Wizard {

	private final EClass eClass;

	/**
	 * Initialisiert den Wizard.
	 * 
	 * @param eClass
	 *            die Klasse der zu exportierenden Objekte.
	 */
	protected AbstractWizard(final EClass eClass) {
		this.eClass = eClass;
	}

	/**
	 * Gibt den Typ der zu exportierenden Objekte zurck.
	 */
	protected EClass getEClass() {
		return eClass;
	}

}
