package de.bsvrz.buv.plugin.dobj.actions;

import org.eclipse.gef.SharedImages;
import org.eclipse.gef.tools.MarqueeSelectionTool;
import org.eclipse.ui.IWorkbenchPart;

import de.bsvrz.buv.plugin.dobj.internal.DobjMessages;
import de.bsvrz.buv.plugin.dobj.tools.RectangleSelectionTool;

/**
 * Action zum Aktivieren des {@link MarqueeSelectionTool}.
 * 
 * @author BitCtrl Systems GmbH, Falko Schumann
 * @version $Id$
 */
public class RectangleSelectionAction extends AbstractToolAction {

	/**
	 * Initialisiert die Action.
	 * 
	 * @param part
	 *            der Workbench Part fr den die Action verwendet werden soll.
	 */
	public RectangleSelectionAction(final IWorkbenchPart part) {
		super(part, DobjMessages.RectangleSelection_Label,
				new RectangleSelectionTool());
		setToolTipText(DobjMessages.RectangleSelection_Tooltip);
		setId(DobjActionFactory.SELECTION_RECTANGLE.getCommandId());
		setActionDefinitionId(DobjActionFactory.SELECTION_RECTANGLE
				.getCommandId());
		setImageDescriptor(SharedImages.DESC_MARQUEE_TOOL_16);
	}

}
