package de.bsvrz.buv.plugin.dobj.actions;

import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.part.WorkbenchPart;

import de.bsvrz.buv.plugin.dobj.internal.DobjMessages;
import de.bsvrz.buv.plugin.dobj.tools.StreckeSelectionTool;
import de.bsvrz.buv.plugin.dobj.util.DobjIcons;

/**
 * Aktion zum Aktivieren des {@link StreckeSelectionTool}.
 * 
 * @author BitCtrl Systems GmbH, Falko Schumann
 * @version $Id$
 */
public class StreckeSelectionAction extends AbstractToolAction {

	/**
	 * Initialisiert die Aktion.
	 * 
	 * @param part
	 *            der {@link WorkbenchPart} fr den das Tool verwendet werden
	 *            soll.
	 */
	public StreckeSelectionAction(final IWorkbenchPart part) {
		super(part, DobjMessages.StreckeSelection_Label,
				new StreckeSelectionTool());
		setToolTipText(DobjMessages.StreckeSelection_Tooltip);
		setId(DobjActionFactory.SELECTION_STRECKE.getCommandId());
		setActionDefinitionId(DobjActionFactory.SELECTION_STRECKE
				.getCommandId());
		setImageDescriptor(DobjIcons.ActionSelectionStrecke
				.getImageDescriptor());
	}

}
