package de.bsvrz.buv.plugin.dobj.actions;

import org.eclipse.jface.action.Action;

import de.bsvrz.buv.plugin.dobj.internal.DobjMessages;
import de.bsvrz.buv.plugin.dobj.util.DobjIcons;
import de.bsvrz.buv.plugin.dobj.util.SelectionProperties;

/**
 * Aktiviert und Deaktiviert die Teilselektion. Wenn die Teilselektion aktiviert
 * ist, sollen nicht nur Objekt ausgewhlt werden, die sich komplett innerhalb
 * des Selektionsrahmens befinden, sondern auch die die den Rahmen schneiden.
 * 
 * @author BitCtrl Systems GmbH, Falko Schumann
 * @version $Id: ToggleTouchedSelectionAction.java 26043 2010-09-02 11:06:04Z Schumann $
 */
public class ToggleTouchedSelectionAction extends Action {

	private final SelectionProperties properties;

	/**
	 * Initialisiert die Action.
	 * 
	 * @param properties
	 *            die zu verwaltenden Selektionseigenschaften.
	 */
	public ToggleTouchedSelectionAction(final SelectionProperties properties) {
		super(DobjMessages.ToggleTouchedSelection_Label, AS_CHECK_BOX);
		this.properties = properties;

		setImageDescriptor(DobjIcons.ActionToggleTouchedSelection
				.getImageDescriptor());
		setToolTipText(DobjMessages.ToggleTouchedSelection_Tooltip);

		setId(DobjActionFactory.TOGGLE_TOUCHED_SELECTION.getCommandId());
		setActionDefinitionId(DobjActionFactory.TOGGLE_TOUCHED_SELECTION
				.getCommandId());

		setChecked(properties.isSelectTouched());
	}

	@Override
	public void run() {
		properties.setSelectTouched(!properties.isSelectTouched());
		setChecked(properties.isSelectTouched());
	}

}
