/**
 * Darstellungsobjekte - Decorator
 * Copyright (C) 2012 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weienfelser Strae 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */
package de.bsvrz.buv.plugin.dobj.decorator.model;

import org.eclipse.emf.ecore.EObject;

import org.eclipse.swt.graphics.RGB;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Stoerfall Indikator Decorator</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getStoerungFarbe <em>Stoerung Farbe</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getKeineAussageFarbe <em>Keine Aussage Farbe</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getFreierVerkehrFarbe <em>Freier Verkehr Farbe</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getLebhafterVerkehrFarbe <em>Lebhafter Verkehr Farbe</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getDichterVerkehrFarbe <em>Dichter Verkehr Farbe</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getZaehfliessenderVerkehrFarbe <em>Zaehfliessender Verkehr Farbe</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getStockenderVerkehrFarbe <em>Stockender Verkehr Farbe</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getStauFarbe <em>Stau Farbe</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.bsvrz.buv.plugin.dobj.decorator.model.DobjDecoratorPackage#getStoerfallIndikatorDecorator()
 * @model interface="true" abstract="true"
 * @generated
 */
public interface StoerfallIndikatorDecorator extends EObject {
	/**
	 * Returns the value of the '<em><b>Stoerung Farbe</b></em>' attribute.
	 * The default value is <code>"255,255,255"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Stoerung Farbe</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Stoerung Farbe</em>' attribute.
	 * @see #isSetStoerungFarbe()
	 * @see #unsetStoerungFarbe()
	 * @see #setStoerungFarbe(RGB)
	 * @see de.bsvrz.buv.plugin.dobj.decorator.model.DobjDecoratorPackage#getStoerfallIndikatorDecorator_StoerungFarbe()
	 * @model default="255,255,255" unsettable="true" dataType="com.bitctrl.lib.eclipse.emf.eclipse.model.RGB"
	 * @generated
	 */
	RGB getStoerungFarbe();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getStoerungFarbe <em>Stoerung Farbe</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Stoerung Farbe</em>' attribute.
	 * @see #isSetStoerungFarbe()
	 * @see #unsetStoerungFarbe()
	 * @see #getStoerungFarbe()
	 * @generated
	 */
	void setStoerungFarbe(RGB value);

	/**
	 * Unsets the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getStoerungFarbe <em>Stoerung Farbe</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetStoerungFarbe()
	 * @see #getStoerungFarbe()
	 * @see #setStoerungFarbe(RGB)
	 * @generated
	 */
	void unsetStoerungFarbe();

	/**
	 * Returns whether the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getStoerungFarbe <em>Stoerung Farbe</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Stoerung Farbe</em>' attribute is set.
	 * @see #unsetStoerungFarbe()
	 * @see #getStoerungFarbe()
	 * @see #setStoerungFarbe(RGB)
	 * @generated
	 */
	boolean isSetStoerungFarbe();

	/**
	 * Returns the value of the '<em><b>Keine Aussage Farbe</b></em>' attribute.
	 * The default value is <code>"128,128,128"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Keine Aussage Farbe</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Keine Aussage Farbe</em>' attribute.
	 * @see #isSetKeineAussageFarbe()
	 * @see #unsetKeineAussageFarbe()
	 * @see #setKeineAussageFarbe(RGB)
	 * @see de.bsvrz.buv.plugin.dobj.decorator.model.DobjDecoratorPackage#getStoerfallIndikatorDecorator_KeineAussageFarbe()
	 * @model default="128,128,128" unsettable="true" dataType="com.bitctrl.lib.eclipse.emf.eclipse.model.RGB"
	 * @generated
	 */
	RGB getKeineAussageFarbe();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getKeineAussageFarbe <em>Keine Aussage Farbe</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Keine Aussage Farbe</em>' attribute.
	 * @see #isSetKeineAussageFarbe()
	 * @see #unsetKeineAussageFarbe()
	 * @see #getKeineAussageFarbe()
	 * @generated
	 */
	void setKeineAussageFarbe(RGB value);

	/**
	 * Unsets the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getKeineAussageFarbe <em>Keine Aussage Farbe</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetKeineAussageFarbe()
	 * @see #getKeineAussageFarbe()
	 * @see #setKeineAussageFarbe(RGB)
	 * @generated
	 */
	void unsetKeineAussageFarbe();

	/**
	 * Returns whether the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getKeineAussageFarbe <em>Keine Aussage Farbe</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Keine Aussage Farbe</em>' attribute is set.
	 * @see #unsetKeineAussageFarbe()
	 * @see #getKeineAussageFarbe()
	 * @see #setKeineAussageFarbe(RGB)
	 * @generated
	 */
	boolean isSetKeineAussageFarbe();

	/**
	 * Returns the value of the '<em><b>Freier Verkehr Farbe</b></em>' attribute.
	 * The default value is <code>"96,255,96"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Freier Verkehr Farbe</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Freier Verkehr Farbe</em>' attribute.
	 * @see #isSetFreierVerkehrFarbe()
	 * @see #unsetFreierVerkehrFarbe()
	 * @see #setFreierVerkehrFarbe(RGB)
	 * @see de.bsvrz.buv.plugin.dobj.decorator.model.DobjDecoratorPackage#getStoerfallIndikatorDecorator_FreierVerkehrFarbe()
	 * @model default="96,255,96" unsettable="true" dataType="com.bitctrl.lib.eclipse.emf.eclipse.model.RGB"
	 * @generated
	 */
	RGB getFreierVerkehrFarbe();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getFreierVerkehrFarbe <em>Freier Verkehr Farbe</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Freier Verkehr Farbe</em>' attribute.
	 * @see #isSetFreierVerkehrFarbe()
	 * @see #unsetFreierVerkehrFarbe()
	 * @see #getFreierVerkehrFarbe()
	 * @generated
	 */
	void setFreierVerkehrFarbe(RGB value);

	/**
	 * Unsets the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getFreierVerkehrFarbe <em>Freier Verkehr Farbe</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetFreierVerkehrFarbe()
	 * @see #getFreierVerkehrFarbe()
	 * @see #setFreierVerkehrFarbe(RGB)
	 * @generated
	 */
	void unsetFreierVerkehrFarbe();

	/**
	 * Returns whether the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getFreierVerkehrFarbe <em>Freier Verkehr Farbe</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Freier Verkehr Farbe</em>' attribute is set.
	 * @see #unsetFreierVerkehrFarbe()
	 * @see #getFreierVerkehrFarbe()
	 * @see #setFreierVerkehrFarbe(RGB)
	 * @generated
	 */
	boolean isSetFreierVerkehrFarbe();

	/**
	 * Returns the value of the '<em><b>Lebhafter Verkehr Farbe</b></em>' attribute.
	 * The default value is <code>"0,127,0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Lebhafter Verkehr Farbe</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Lebhafter Verkehr Farbe</em>' attribute.
	 * @see #isSetLebhafterVerkehrFarbe()
	 * @see #unsetLebhafterVerkehrFarbe()
	 * @see #setLebhafterVerkehrFarbe(RGB)
	 * @see de.bsvrz.buv.plugin.dobj.decorator.model.DobjDecoratorPackage#getStoerfallIndikatorDecorator_LebhafterVerkehrFarbe()
	 * @model default="0,127,0" unsettable="true" dataType="com.bitctrl.lib.eclipse.emf.eclipse.model.RGB"
	 * @generated
	 */
	RGB getLebhafterVerkehrFarbe();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getLebhafterVerkehrFarbe <em>Lebhafter Verkehr Farbe</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Lebhafter Verkehr Farbe</em>' attribute.
	 * @see #isSetLebhafterVerkehrFarbe()
	 * @see #unsetLebhafterVerkehrFarbe()
	 * @see #getLebhafterVerkehrFarbe()
	 * @generated
	 */
	void setLebhafterVerkehrFarbe(RGB value);

	/**
	 * Unsets the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getLebhafterVerkehrFarbe <em>Lebhafter Verkehr Farbe</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetLebhafterVerkehrFarbe()
	 * @see #getLebhafterVerkehrFarbe()
	 * @see #setLebhafterVerkehrFarbe(RGB)
	 * @generated
	 */
	void unsetLebhafterVerkehrFarbe();

	/**
	 * Returns whether the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getLebhafterVerkehrFarbe <em>Lebhafter Verkehr Farbe</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Lebhafter Verkehr Farbe</em>' attribute is set.
	 * @see #unsetLebhafterVerkehrFarbe()
	 * @see #getLebhafterVerkehrFarbe()
	 * @see #setLebhafterVerkehrFarbe(RGB)
	 * @generated
	 */
	boolean isSetLebhafterVerkehrFarbe();

	/**
	 * Returns the value of the '<em><b>Dichter Verkehr Farbe</b></em>' attribute.
	 * The default value is <code>"255,255,0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Dichter Verkehr Farbe</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Dichter Verkehr Farbe</em>' attribute.
	 * @see #isSetDichterVerkehrFarbe()
	 * @see #unsetDichterVerkehrFarbe()
	 * @see #setDichterVerkehrFarbe(RGB)
	 * @see de.bsvrz.buv.plugin.dobj.decorator.model.DobjDecoratorPackage#getStoerfallIndikatorDecorator_DichterVerkehrFarbe()
	 * @model default="255,255,0" unsettable="true" dataType="com.bitctrl.lib.eclipse.emf.eclipse.model.RGB"
	 * @generated
	 */
	RGB getDichterVerkehrFarbe();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getDichterVerkehrFarbe <em>Dichter Verkehr Farbe</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Dichter Verkehr Farbe</em>' attribute.
	 * @see #isSetDichterVerkehrFarbe()
	 * @see #unsetDichterVerkehrFarbe()
	 * @see #getDichterVerkehrFarbe()
	 * @generated
	 */
	void setDichterVerkehrFarbe(RGB value);

	/**
	 * Unsets the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getDichterVerkehrFarbe <em>Dichter Verkehr Farbe</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetDichterVerkehrFarbe()
	 * @see #getDichterVerkehrFarbe()
	 * @see #setDichterVerkehrFarbe(RGB)
	 * @generated
	 */
	void unsetDichterVerkehrFarbe();

	/**
	 * Returns whether the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getDichterVerkehrFarbe <em>Dichter Verkehr Farbe</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Dichter Verkehr Farbe</em>' attribute is set.
	 * @see #unsetDichterVerkehrFarbe()
	 * @see #getDichterVerkehrFarbe()
	 * @see #setDichterVerkehrFarbe(RGB)
	 * @generated
	 */
	boolean isSetDichterVerkehrFarbe();

	/**
	 * Returns the value of the '<em><b>Zaehfliessender Verkehr Farbe</b></em>' attribute.
	 * The default value is <code>"255,196,0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Zaehfliessender Verkehr Farbe</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Zaehfliessender Verkehr Farbe</em>' attribute.
	 * @see #isSetZaehfliessenderVerkehrFarbe()
	 * @see #unsetZaehfliessenderVerkehrFarbe()
	 * @see #setZaehfliessenderVerkehrFarbe(RGB)
	 * @see de.bsvrz.buv.plugin.dobj.decorator.model.DobjDecoratorPackage#getStoerfallIndikatorDecorator_ZaehfliessenderVerkehrFarbe()
	 * @model default="255,196,0" unsettable="true" dataType="com.bitctrl.lib.eclipse.emf.eclipse.model.RGB"
	 * @generated
	 */
	RGB getZaehfliessenderVerkehrFarbe();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getZaehfliessenderVerkehrFarbe <em>Zaehfliessender Verkehr Farbe</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Zaehfliessender Verkehr Farbe</em>' attribute.
	 * @see #isSetZaehfliessenderVerkehrFarbe()
	 * @see #unsetZaehfliessenderVerkehrFarbe()
	 * @see #getZaehfliessenderVerkehrFarbe()
	 * @generated
	 */
	void setZaehfliessenderVerkehrFarbe(RGB value);

	/**
	 * Unsets the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getZaehfliessenderVerkehrFarbe <em>Zaehfliessender Verkehr Farbe</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetZaehfliessenderVerkehrFarbe()
	 * @see #getZaehfliessenderVerkehrFarbe()
	 * @see #setZaehfliessenderVerkehrFarbe(RGB)
	 * @generated
	 */
	void unsetZaehfliessenderVerkehrFarbe();

	/**
	 * Returns whether the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getZaehfliessenderVerkehrFarbe <em>Zaehfliessender Verkehr Farbe</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Zaehfliessender Verkehr Farbe</em>' attribute is set.
	 * @see #unsetZaehfliessenderVerkehrFarbe()
	 * @see #getZaehfliessenderVerkehrFarbe()
	 * @see #setZaehfliessenderVerkehrFarbe(RGB)
	 * @generated
	 */
	boolean isSetZaehfliessenderVerkehrFarbe();

	/**
	 * Returns the value of the '<em><b>Stockender Verkehr Farbe</b></em>' attribute.
	 * The default value is <code>"255,100,100"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Stockender Verkehr Farbe</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Stockender Verkehr Farbe</em>' attribute.
	 * @see #isSetStockenderVerkehrFarbe()
	 * @see #unsetStockenderVerkehrFarbe()
	 * @see #setStockenderVerkehrFarbe(RGB)
	 * @see de.bsvrz.buv.plugin.dobj.decorator.model.DobjDecoratorPackage#getStoerfallIndikatorDecorator_StockenderVerkehrFarbe()
	 * @model default="255,100,100" unsettable="true" dataType="com.bitctrl.lib.eclipse.emf.eclipse.model.RGB"
	 * @generated
	 */
	RGB getStockenderVerkehrFarbe();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getStockenderVerkehrFarbe <em>Stockender Verkehr Farbe</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Stockender Verkehr Farbe</em>' attribute.
	 * @see #isSetStockenderVerkehrFarbe()
	 * @see #unsetStockenderVerkehrFarbe()
	 * @see #getStockenderVerkehrFarbe()
	 * @generated
	 */
	void setStockenderVerkehrFarbe(RGB value);

	/**
	 * Unsets the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getStockenderVerkehrFarbe <em>Stockender Verkehr Farbe</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetStockenderVerkehrFarbe()
	 * @see #getStockenderVerkehrFarbe()
	 * @see #setStockenderVerkehrFarbe(RGB)
	 * @generated
	 */
	void unsetStockenderVerkehrFarbe();

	/**
	 * Returns whether the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getStockenderVerkehrFarbe <em>Stockender Verkehr Farbe</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Stockender Verkehr Farbe</em>' attribute is set.
	 * @see #unsetStockenderVerkehrFarbe()
	 * @see #getStockenderVerkehrFarbe()
	 * @see #setStockenderVerkehrFarbe(RGB)
	 * @generated
	 */
	boolean isSetStockenderVerkehrFarbe();

	/**
	 * Returns the value of the '<em><b>Stau Farbe</b></em>' attribute.
	 * The default value is <code>"255,0,0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Stau Farbe</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Stau Farbe</em>' attribute.
	 * @see #isSetStauFarbe()
	 * @see #unsetStauFarbe()
	 * @see #setStauFarbe(RGB)
	 * @see de.bsvrz.buv.plugin.dobj.decorator.model.DobjDecoratorPackage#getStoerfallIndikatorDecorator_StauFarbe()
	 * @model default="255,0,0" unsettable="true" dataType="com.bitctrl.lib.eclipse.emf.eclipse.model.RGB"
	 * @generated
	 */
	RGB getStauFarbe();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getStauFarbe <em>Stau Farbe</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Stau Farbe</em>' attribute.
	 * @see #isSetStauFarbe()
	 * @see #unsetStauFarbe()
	 * @see #getStauFarbe()
	 * @generated
	 */
	void setStauFarbe(RGB value);

	/**
	 * Unsets the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getStauFarbe <em>Stau Farbe</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetStauFarbe()
	 * @see #getStauFarbe()
	 * @see #setStauFarbe(RGB)
	 * @generated
	 */
	void unsetStauFarbe();

	/**
	 * Returns whether the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.StoerfallIndikatorDecorator#getStauFarbe <em>Stau Farbe</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Stau Farbe</em>' attribute is set.
	 * @see #unsetStauFarbe()
	 * @see #getStauFarbe()
	 * @see #setStauFarbe(RGB)
	 * @generated
	 */
	boolean isSetStauFarbe();

} // StoerfallIndikatorDecorator
