/**
 * Darstellungsobjekte - Decorator
 * Copyright (C) 2012 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weienfelser Strae 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */
package de.bsvrz.buv.plugin.dobj.decorator.model;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Transparenz Decorator</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.bsvrz.buv.plugin.dobj.decorator.model.TransparenzDecorator#getTransparenz <em>Transparenz</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.bsvrz.buv.plugin.dobj.decorator.model.DobjDecoratorPackage#getTransparenzDecorator()
 * @model interface="true" abstract="true"
 * @generated
 */
public interface TransparenzDecorator extends EObject {
	/**
	 * Returns the value of the '<em><b>Transparenz</b></em>' attribute.
	 * The default value is <code>"255"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Transparenz</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Transparenz</em>' attribute.
	 * @see #isSetTransparenz()
	 * @see #unsetTransparenz()
	 * @see #setTransparenz(int)
	 * @see de.bsvrz.buv.plugin.dobj.decorator.model.DobjDecoratorPackage#getTransparenzDecorator_Transparenz()
	 * @model default="255" unsettable="true"
	 * @generated
	 */
	int getTransparenz();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.TransparenzDecorator#getTransparenz <em>Transparenz</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Transparenz</em>' attribute.
	 * @see #isSetTransparenz()
	 * @see #unsetTransparenz()
	 * @see #getTransparenz()
	 * @generated
	 */
	void setTransparenz(int value);

	/**
	 * Unsets the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.TransparenzDecorator#getTransparenz <em>Transparenz</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetTransparenz()
	 * @see #getTransparenz()
	 * @see #setTransparenz(int)
	 * @generated
	 */
	void unsetTransparenz();

	/**
	 * Returns whether the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.TransparenzDecorator#getTransparenz <em>Transparenz</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Transparenz</em>' attribute is set.
	 * @see #unsetTransparenz()
	 * @see #getTransparenz()
	 * @see #setTransparenz(int)
	 * @generated
	 */
	boolean isSetTransparenz();

} // TransparenzDecorator
