package de.bsvrz.buv.plugin.dobj.figures;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.Tool;
import org.eclipse.swt.widgets.Display;

/**
 * Rechteckige Feedback Figure fr {@link Tool}s.
 * 
 * @author BitCtrl Systems GmbH, Falko Schumann
 * @version $Id: AnimatedRectangleFeedbackFigure.java 26023 2010-09-01 16:54:32Z Schumann $
 */
public class AnimatedRectangleFeedbackFigure extends Figure {

	private static final int DELAY = 110; // animation delay in millisecond
	private int offset = 0;
	private boolean schedulePaint = true;

	@Override
	protected void paintFigure(final Graphics graphics) {
		final Rectangle boundsCopy = getBounds().getCopy();
		graphics.translate(getLocation());

		// XXX Geht nicht unter Mac OS X?!
		graphics.setXORMode(true);
		graphics.setForegroundColor(ColorConstants.white);
		graphics.setBackgroundColor(ColorConstants.black);

		graphics.setLineStyle(Graphics.LINE_DOT);

		final int[] points = new int[6];

		points[0] = 0 + offset;
		points[1] = 0;
		points[2] = boundsCopy.width - 1;
		points[3] = 0;
		points[4] = boundsCopy.width - 1;
		points[5] = boundsCopy.height - 1;

		graphics.drawPolyline(points);

		points[0] = 0;
		points[1] = 0 + offset;
		points[2] = 0;
		points[3] = boundsCopy.height - 1;
		points[4] = boundsCopy.width - 1;
		points[5] = boundsCopy.height - 1;

		graphics.drawPolyline(points);
		graphics.translate(getLocation().getNegated());

		if (schedulePaint) {
			Display.getCurrent().timerExec(DELAY, new Runnable() {
				@Override
				public void run() {
					offset++;
					if (offset > 5) {
						offset = 0;
					}

					schedulePaint = true;
					repaint();
				}
			});
		}

		schedulePaint = false;
	}

}
