package de.bsvrz.buv.plugin.dobj.figures;

import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.gef.Tool;
import org.eclipse.swt.SWT;

/**
 * Linienartige Feedback Figure fr {@link Tool}s.
 * 
 * @author BitCtrl Systems GmbH, Falko Schumann
 * @version $Id$
 */
public class LineFeedbackFigure extends Shape {

	private Point start;
	private Point end;

	{
		setLineStyle(SWT.LINE_DASH);
	}

	/**
	 * Gibt den Startpunkt der Linie zurck.
	 * 
	 * @return der Startpunkt der Linie.
	 */
	public Point getStart() {
		return start;
	}

	/**
	 * Legt den Startpunkt der Linie fest.
	 * 
	 * @param start
	 *            der Startpunkt der Linie.
	 */
	public void setStart(final Point start) {
		this.start = start;
	}

	/**
	 * Gibt den Endpunkt der Linie zurck.
	 * 
	 * @return der Endpunkt der Linie.
	 */
	public Point getEnd() {
		return end;
	}

	/**
	 * Legt den Endpunkt der Linie fest.
	 * 
	 * @param end
	 *            der Endpunkt der Linie.
	 */
	public void setEnd(final Point end) {
		this.end = end;
	}

	@Override
	protected void fillShape(final Graphics graphics) {
		// tut nix
	}

	@Override
	protected void outlineShape(final Graphics graphics) {
		graphics.drawLine(start, end);
	}

}
