/*
 * Rahmenwerk-Plug-in "Darstellungsobjekte"
 * Copyright (C) 2009 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weissenfelser Strasse 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.buv.plugin.dobj.kollision;

import org.eclipse.core.runtime.Platform;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Point;

/**
 * Ueberdeckungsfunktion fuer Objekt, dessen {@link IFigure#getBounds()}-Methode
 * nicht die richtigen (die gemeinten) Bounds zurueck gibt.
 * 
 * @author BitCtrl Systems GmbH, thierfelder
 * @version $Id$
 */
public class UeberdeckungsFunktionFuerExtraBounds implements
		IUeberdeckungsFunktion {

	static final UeberdeckungsFunktionFuerExtraBounds INSTANZ = new UeberdeckungsFunktionFuerExtraBounds();

	public double getUeberdeckungsKoeffizient(final Point o1Ort,
			final Object o1, final Object o2) {
		IArrangierbaresObjektMitExtraBounds a1 = (IArrangierbaresObjektMitExtraBounds) Platform
				.getAdapterManager().getAdapter(o1,
						IArrangierbaresObjektMitExtraBounds.class);
		IArrangierbaresObjektMitExtraBounds a2 = (IArrangierbaresObjektMitExtraBounds) Platform
				.getAdapterManager().getAdapter(o2,
						IArrangierbaresObjektMitExtraBounds.class);
		if (a1 != null && a2 != null) {
			return StandardUeberdeckungsFunktion
					.getRectangleUeberdeckungsKoeffizient(o1Ort, a1
							.getExtraBounds(), a2.getExtraBounds());
		}
		return KEINE_UEBERDECKUNG;
	}
}