/**
 * Darstellungsobjekte
 * Copyright (C) 2010 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weienfelser Strae 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 *
 * $Id$
 */
package de.bsvrz.buv.plugin.dobj.model;

import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.jface.resource.ImageDescriptor;

import com.bitctrl.lib.eclipse.emf.eclipse.model.Named;

import de.bsvrz.dav.daf.main.config.SystemObjectType;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Do Typ</b></em>'. <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.bsvrz.buv.plugin.dobj.model.DoTyp#getId <em>Id</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.dobj.model.DoTyp#getDescription <em>Description</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.dobj.model.DoTyp#getSystemObjectType <em>System Object Type</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.dobj.model.DoTyp#getIcon <em>Icon</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.dobj.model.DoTyp#getZoomStufe <em>Zoom Stufe</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.bsvrz.buv.plugin.dobj.model.DobjPackage#getDoTyp()
 * @model abstract="true"
 * @generated
 */
public interface DoTyp extends Named {
	/**
	 * Returns the value of the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Id</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Id</em>' attribute.
	 * @see #setId(String)
	 * @see de.bsvrz.buv.plugin.dobj.model.DobjPackage#getDoTyp_Id()
	 * @model
	 * @generated
	 */
	String getId();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.dobj.model.DoTyp#getId <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Id</em>' attribute.
	 * @see #getId()
	 * @generated
	 */
	void setId(String value);

	/**
	 * Returns the value of the '<em><b>Description</b></em>' attribute. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Description</em>' attribute isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Description</em>' attribute.
	 * @see de.bsvrz.buv.plugin.dobj.model.DobjPackage#getDoTyp_Description()
	 * @model transient="true" changeable="false"
	 * @generated
	 */
	String getDescription();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.dobj.model.DoTyp#getDescription <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Description</em>' attribute.
	 * @see #getDescription()
	 * @generated
	 */
	void setDescription(String value);

	/**
	 * Returns the value of the '<em><b>System Object Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>System Object Type</em>' attribute isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>System Object Type</em>' attribute.
	 * @see #setSystemObjectType(SystemObjectType)
	 * @see de.bsvrz.buv.plugin.dobj.model.DobjPackage#getDoTyp_SystemObjectType()
	 * @model dataType="com.bitctrl.lib.eclipse.emf.dav.model.SystemObjectType" transient="true"
	 * @generated
	 */
	SystemObjectType getSystemObjectType();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.dobj.model.DoTyp#getSystemObjectType <em>System Object Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>System Object Type</em>' attribute.
	 * @see #getSystemObjectType()
	 * @generated
	 */
	void setSystemObjectType(SystemObjectType value);

	/**
	 * Returns the value of the '<em><b>Icon</b></em>' attribute. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Icon</em>' attribute isn't clear, there really
	 * should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Icon</em>' attribute.
	 * @see de.bsvrz.buv.plugin.dobj.model.DobjPackage#getDoTyp_Icon()
	 * @model 
	 *        dataType="com.bitctrl.lib.eclipse.emf.eclipse.model.ImageDescriptor"
	 *        transient="true" changeable="false"
	 * @generated
	 */
	ImageDescriptor getIcon();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.dobj.model.DoTyp#getIcon <em>Icon</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Icon</em>' attribute.
	 * @see #getIcon()
	 * @generated
	 */
	void setIcon(ImageDescriptor value);

	/**
	 * Returns the value of the '<em><b>Zoom Stufe</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Zoom Stufe</em>' reference isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Zoom Stufe</em>' containment reference.
	 * @see #setZoomStufe(ZoomStufe)
	 * @see de.bsvrz.buv.plugin.dobj.model.DobjPackage#getDoTyp_ZoomStufe()
	 * @model containment="true"
	 * @generated
	 */
	ZoomStufe getZoomStufe();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.dobj.model.DoTyp#getZoomStufe <em>Zoom Stufe</em>}' containment reference.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @param value the new value of the '<em>Zoom Stufe</em>' containment reference.
	 * @see #getZoomStufe()
	 * @generated
	 */
	void setZoomStufe(ZoomStufe value);

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	DoModel createModel();

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @model dataType="com.bitctrl.lib.eclipse.emf.gef.model.GraphicalEditPart"
	 * @generated
	 */
	GraphicalEditPart createController();

} // DoTyp
