package de.bsvrz.buv.plugin.dobj.properties;

import org.eclipse.gef.EditPart;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.graphics.Image;

import com.bitctrl.lib.eclipse.emf.viewers.EmfLabelProvider;

/**
 * Allgemeiner Label Provider fr die Titel Section von Tabbed Properties.
 * 
 * @author BitCtrl Systems GmbH, Falko Schumann
 * @version $Id$
 */
public class ContributorLabelProvider extends EmfLabelProvider {

	@Override
	public String getText(final Object element) {
		if (element instanceof IStructuredSelection) {
			return getText(((IStructuredSelection) element).getFirstElement());
		} else if (element instanceof EditPart) {
			return getText(((EditPart) element).getModel());
		}

		return super.getText(element);
	}

	@Override
	public Image getImage(final Object element) {
		if (element instanceof IStructuredSelection) {
			return getImage(((IStructuredSelection) element).getFirstElement());
		} else if (element instanceof EditPart) {
			return getImage(((EditPart) element).getModel());
		}

		return super.getImage(element);
	}

}
