package de.bsvrz.buv.plugin.dobj.requests;

import org.eclipse.gef.Request;

/**
 * Request zur Aufforderung den Edit Part online- oder offlinezuschalten.
 * 
 * @author BitCtrl Systems GmbH, Falko Schumann
 * @version $Id: OnlineRequest.java 26112 2010-09-04 13:37:18Z Schumann $
 */
public class OnlineRequest extends Request {

	private final boolean online;

	/**
	 * Initialisiert den Request.
	 * 
	 * @param online
	 *            <code>true</code>, wenn der Edit Part Online geschaltet werden
	 *            soll und <code>false</code>, wenn der Edit Part Offline
	 *            geschalten werden soll.
	 */
	public OnlineRequest(final boolean online) {
		super(DobjRequestConstants.REQ_ONLINE);
		this.online = online;
	}

	/**
	 * Gibt das Flag zurck, ob der Edit Online geschalten werden soll.
	 * 
	 * @return <code>true</code>, wenn der Edit Part Online geschaltet werden
	 *         soll und <code>false</code>, wenn der Edit Part Offline
	 *         geschalten werden soll.
	 */
	public boolean isOnline() {
		return online;
	}

}
