package de.bsvrz.buv.plugin.dobj.util;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.graphics.Cursor;
import org.eclipse.swt.graphics.Image;

import de.bsvrz.buv.plugin.dobj.internal.DObjPlugin;

/**
 * Stellt gemeinsam nutzbare Cursor zur Verfgung.
 * 
 * @author BitCtrl Systems GmbH, Schumann
 * @version $Id$
 */
public enum DobjCursors {

	/** Der Cursor zum Hineinzoomen in eine Rechteckauswahl. */
	ZoomIn("icons/16x16/actions/zoom-in.gif");

	private final Cursor cursor;

	private DobjCursors(final String imagePath) {
		final ImageDescriptor imageDescriptor = DObjPlugin.getDefault()
				.getImageDescriptor(imagePath);
		if (imageDescriptor != null) {
			final Image image = imageDescriptor.createImage();
			cursor = new Cursor(null, image.getImageData(), 0, 0);
			image.dispose();
		} else {
			cursor = null;
			final String message = "Datei nicht gefunden: " + imagePath;
			DObjPlugin.getDefault().getLogger().error(message);
		}
	}

	/**
	 * Gibt den gemeinsamen Cursor zurck.
	 */
	public Cursor getCursor() {
		return cursor;
	}

}
