package de.bsvrz.buv.plugin.dobj.util;

import java.util.EventObject;

import de.bsvrz.sys.funclib.bitctrl.modell.bitctrlallgemein.objekte.PortableBitMap;

/**
 * Dieses Event wird verteilt, wenn sich die in der Konfiguration des
 * Datenverteilers vorhandenen {@link PortableBitMap}s gendert haben.
 * 
 * @author BitCtrl Systems GmbH, Uwe Peuker
 * @version $Id$
 */
public class PortableBitMapEvent extends EventObject {

	private static final long serialVersionUID = 1L;

	private final PortableBitMap portableBitMap;

	/**
	 * Initialisiert das Event.
	 * 
	 * @param source
	 *            die Quelle des Events.
	 * @param portableBitmap
	 *            die {@link PortableBitMap}, die sich gendert hat.
	 */
	public PortableBitMapEvent(final PortableBitMapManager source,
			final PortableBitMap portableBitmap) {
		super(source);
		portableBitMap = portableBitmap;
	}

	/**
	 * liefert die {@link PortableBitMap}, die sich gendert hat zurck.
	 * 
	 * @return die genderte {@link PortableBitMap}.
	 */
	public PortableBitMap getPortableBitMap() {
		return portableBitMap;
	}

}
