package de.bsvrz.buv.plugin.dobj.util;

import java.util.EventListener;

import de.bsvrz.sys.funclib.bitctrl.modell.bitctrlallgemein.objekte.PortableBitMap;

/**
 * Listener fr nderungen an den vorhandenen {@link PortableBitMap}s in der
 * Konfiguration des Datenverteilers.
 * 
 * @author BitCtrl Systems GmbH, Uwe Peuker
 * @version $Id$
 */
public interface PortableBitMapListener extends EventListener {

	/**
	 * Eine {@link PortableBitMap} wurde neu angelegt.
	 * 
	 * @param event
	 *            das Event mit dem neuen Bild.
	 */
	void portableBitMapAngelegt(PortableBitMapEvent event);

	/**
	 * Eine vorhandene {@link PortableBitMap} wurde gelscht.
	 * 
	 * @param event
	 *            das Event mit der gelschten {@link PortableBitMap}.
	 */
	void portableBitMapEntfernt(PortableBitMapEvent event);

	/**
	 * Eine vorhandene {@link PortableBitMap} wurde umbenannt.
	 * 
	 * @param event
	 *            das Event mit der umbenannten {@link PortableBitMap}.
	 */
	void portableBitMapUmbenannt(PortableBitMapEvent event);

	/**
	 * der Zustand der Datenverteilerverbindung zur Verwaltung der Fllmuster
	 * hat sich gendert.
	 * 
	 * @param event
	 *            die Ereignisdaten
	 */
	void portableBitMapConnection(PortableBitMapEvent event);
}
