/**
 * Rahmenwerk-Plug-in "Darstellungsobjekte"
 * Copyright (C) 2010 BitCtrl Systems GmbH 
 *  
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weissenfelser Strasse 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 * 
 * 
 */
package de.bsvrz.buv.plugin.doeditor.model;

import org.eclipse.emf.common.util.EList;

import de.bsvrz.buv.plugin.dobj.decorator.model.DrehungDecorator;
import de.bsvrz.buv.plugin.dobj.decorator.model.SkalierungDecorator;
import de.bsvrz.buv.plugin.dobj.model.DoTyp;
import de.bsvrz.sys.funclib.bitctrl.modell.SystemObjekt;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Editor Do Typ Referenz</b></em>'. <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.EditorDoTypReferenz#getSystemObjekt <em>System Objekt</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.EditorDoTypReferenz#getWrapped <em>Wrapped</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.bsvrz.buv.plugin.doeditor.model.DoeditorPackage#getEditorDoTypReferenz()
 * @model
 * @generated
 */
public interface EditorDoTypReferenz extends DoTyp, SkalierungDecorator,
		DrehungDecorator {
	/**
	 * Returns the value of the '<em><b>System Objekt</b></em>' attribute. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>System Objekt</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>System Objekt</em>' attribute.
	 * @see #setSystemObjekt(SystemObjekt)
	 * @see de.bsvrz.buv.plugin.doeditor.model.DoeditorPackage#getEditorDoTypReferenz_SystemObjekt()
	 * @model 
	 *        dataType="com.bitctrl.lib.eclipse.emf.davbitctrl.model.SystemObjekt"
	 *        required="true"
	 * @generated
	 */
	SystemObjekt getSystemObjekt();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.doeditor.model.EditorDoTypReferenz#getSystemObjekt <em>System Objekt</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @param value the new value of the '<em>System Objekt</em>' attribute.
	 * @see #getSystemObjekt()
	 * @generated
	 */
	void setSystemObjekt(SystemObjekt value);

	/**
	 * Returns the value of the '<em><b>Wrapped</b></em>' reference. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Wrapped</em>' reference isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Wrapped</em>' reference.
	 * @see de.bsvrz.buv.plugin.doeditor.model.DoeditorPackage#getEditorDoTypReferenz_Wrapped()
	 * @model transient="true" changeable="false"
	 * @generated
	 */
	EditorDoTyp getWrapped();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.doeditor.model.EditorDoTypReferenz#getWrapped <em>Wrapped</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Wrapped</em>' reference.
	 * @see #getWrapped()
	 * @generated
	 */
	void setWrapped(EditorDoTyp value);

} // EditorDoTypReferenz
