/*
 * Rahmenwerk-Plug-in "Darstellungsobjekttyp-Editor"
 * Copyright (C) 2010 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weissenfelser Strasse 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.buv.plugin.doeditor.model;

import org.eclipse.draw2d.geometry.Rectangle;

import com.bitctrl.lib.eclipse.emf.eclipse.model.EColor;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Punkt Form</b></em>'. <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.PunktForm#getPositionierung <em>Positionierung</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.PunktForm#getBounds <em>Bounds</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.PunktForm#getForegroundColor <em>Foreground Color</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.bsvrz.buv.plugin.doeditor.model.DoeditorPackage#getPunktForm()
 * @model interface="true" abstract="true"
 * @generated
 */
public interface PunktForm extends RotatableForm, ZoomableForm {
	/**
	 * Returns the value of the '<em><b>Foreground Color</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Foreground Color</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Foreground Color</em>' containment reference.
	 * @see #setForegroundColor(EColor)
	 * @see de.bsvrz.buv.plugin.doeditor.model.DoeditorPackage#getPunktForm_ForegroundColor()
	 * @model containment="true"
	 * @generated
	 */
	EColor getForegroundColor();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.doeditor.model.PunktForm#getForegroundColor <em>Foreground Color</em>}' containment reference.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Foreground Color</em>' containment reference.
	 * @see #getForegroundColor()
	 * @generated
	 */
	void setForegroundColor(EColor value);

	/**
	 * Returns the value of the '<em><b>Positionierung</b></em>' attribute. The
	 * literals are from the enumeration
	 * {@link de.bsvrz.buv.plugin.doeditor.model.Positionierung}. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Positionierung</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Positionierung</em>' attribute.
	 * @see de.bsvrz.buv.plugin.doeditor.model.Positionierung
	 * @see #setPositionierung(Positionierung)
	 * @see de.bsvrz.buv.plugin.doeditor.model.DoeditorPackage#getPunktForm_Positionierung()
	 * @model
	 * @generated
	 */
	Positionierung getPositionierung();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.doeditor.model.PunktForm#getPositionierung <em>Positionierung</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @param value the new value of the '<em>Positionierung</em>' attribute.
	 * @see de.bsvrz.buv.plugin.doeditor.model.Positionierung
	 * @see #getPositionierung()
	 * @generated
	 */
	void setPositionierung(Positionierung value);

	/**
	 * Returns the value of the '<em><b>Bounds</b></em>' attribute. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Bounds</em>' attribute isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Bounds</em>' attribute.
	 * @see #setBounds(Rectangle)
	 * @see de.bsvrz.buv.plugin.doeditor.model.DoeditorPackage#getPunktForm_Bounds()
	 * @model dataType="com.bitctrl.lib.eclipse.emf.gef.model.Rectangle"
	 *        transient="true" volatile="true"
	 * @generated
	 */
	Rectangle getBounds();

	/**
	 * Sets the value of the '
	 * {@link de.bsvrz.buv.plugin.doeditor.model.PunktForm#getBounds
	 * <em>Bounds</em>}' attribute. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @param value
	 *            the new value of the '<em>Bounds</em>' attribute.
	 * @see #getBounds()
	 * @generated
	 */
	void setBounds(Rectangle value);

} // PunktForm
