/*
 * Rahmenwerk-Plug-in "Darstellungsobjekttyp-Editor"
 * Copyright (C) 2010 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weissenfelser Strasse 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.buv.plugin.doeditor.model;

import com.bitctrl.lib.eclipse.emf.eclipse.model.EFont;
import com.bitctrl.lib.eclipse.emf.eclipse.model.HorizontalAlignment;
import com.bitctrl.lib.eclipse.emf.eclipse.model.VerticalAlignment;
import com.bitctrl.lib.eclipse.emf.gef.model.Sized;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Text Form</b></em>'. <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.TextForm#getText <em>Text</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.TextForm#getHorizontalAlignment <em>Horizontal Alignment</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.TextForm#getVerticalAlignment <em>Vertical Alignment</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.TextForm#getFont <em>Font</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.bsvrz.buv.plugin.doeditor.model.DoeditorPackage#getTextForm()
 * @model
 * @generated
 */
public interface TextForm extends FlaechenForm, Sized, BorderedForm {
	/**
	 * Returns the value of the '<em><b>Text</b></em>' attribute.
	 * The default value is <code>"Text"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Text</em>' attribute isn't clear, there really
	 * should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Text</em>' attribute.
	 * @see #setText(String)
	 * @see de.bsvrz.buv.plugin.doeditor.model.DoeditorPackage#getTextForm_Text()
	 * @model default="Text"
	 * @generated
	 */
	String getText();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.doeditor.model.TextForm#getText <em>Text</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Text</em>' attribute.
	 * @see #getText()
	 * @generated
	 */
	void setText(String value);

	/**
	 * Returns the value of the '<em><b>Horizontal Alignment</b></em>' attribute.
	 * The literals are from the enumeration {@link com.bitctrl.lib.eclipse.emf.eclipse.model.HorizontalAlignment}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Horizontal Alignment</em>' attribute isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Horizontal Alignment</em>' attribute.
	 * @see com.bitctrl.lib.eclipse.emf.eclipse.model.HorizontalAlignment
	 * @see #setHorizontalAlignment(HorizontalAlignment)
	 * @see de.bsvrz.buv.plugin.doeditor.model.DoeditorPackage#getTextForm_HorizontalAlignment()
	 * @model
	 * @generated
	 */
	HorizontalAlignment getHorizontalAlignment();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.doeditor.model.TextForm#getHorizontalAlignment <em>Horizontal Alignment</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @param value the new value of the '<em>Horizontal Alignment</em>' attribute.
	 * @see com.bitctrl.lib.eclipse.emf.eclipse.model.HorizontalAlignment
	 * @see #getHorizontalAlignment()
	 * @generated
	 */
	void setHorizontalAlignment(HorizontalAlignment value);

	/**
	 * Returns the value of the '<em><b>Vertical Alignment</b></em>' attribute.
	 * The literals are from the enumeration
	 * {@link com.bitctrl.lib.eclipse.emf.eclipse.model.VerticalAlignment}. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Vertical Alignment</em>' attribute isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Vertical Alignment</em>' attribute.
	 * @see com.bitctrl.lib.eclipse.emf.eclipse.model.VerticalAlignment
	 * @see #setVerticalAlignment(VerticalAlignment)
	 * @see de.bsvrz.buv.plugin.doeditor.model.DoeditorPackage#getTextForm_VerticalAlignment()
	 * @model
	 * @generated
	 */
	VerticalAlignment getVerticalAlignment();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.doeditor.model.TextForm#getVerticalAlignment <em>Vertical Alignment</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @param value the new value of the '<em>Vertical Alignment</em>' attribute.
	 * @see com.bitctrl.lib.eclipse.emf.eclipse.model.VerticalAlignment
	 * @see #getVerticalAlignment()
	 * @generated
	 */
	void setVerticalAlignment(VerticalAlignment value);

	/**
	 * Returns the value of the '<em><b>Font</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Font</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Font</em>' containment reference.
	 * @see #setFont(EFont)
	 * @see de.bsvrz.buv.plugin.doeditor.model.DoeditorPackage#getTextForm_Font()
	 * @model containment="true"
	 * @generated
	 */
	EFont getFont();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.doeditor.model.TextForm#getFont <em>Font</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Font</em>' containment reference.
	 * @see #getFont()
	 * @generated
	 */
	void setFont(EFont value);

} // TextForm
