/*
 * Rahmenwerk-Plug-in "Darstellungsobjekttyp-Editor"
 * Copyright (C) 2010 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weissenfelser Strasse 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.buv.plugin.doeditor.model.impl;

import java.util.Collection;

import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import com.bitctrl.lib.eclipse.emf.eclipse.model.impl.NamedImpl;
import com.bitctrl.lib.eclipse.emf.gef.model.GefPackage;
import com.bitctrl.lib.eclipse.emf.gef.model.Located;

import de.bsvrz.buv.plugin.doeditor.model.BildForm;
import de.bsvrz.buv.plugin.doeditor.model.Decorator;
import de.bsvrz.buv.plugin.doeditor.model.DoeditorPackage;
import de.bsvrz.buv.plugin.doeditor.model.EditorDoTyp;
import de.bsvrz.buv.plugin.doeditor.model.ZoomVerhalten;
import de.bsvrz.buv.plugin.doeditor.model.ZoomableForm;
import de.bsvrz.sys.funclib.bitctrl.modell.bitctrlallgemein.objekte.Bild;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Bild Form</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.impl.BildFormImpl#getLocation <em>Location</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.impl.BildFormImpl#getEditorDoTyp <em>Editor Do Typ</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.impl.BildFormImpl#isVisible <em>Visible</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.impl.BildFormImpl#getDecorators <em>Decorators</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.impl.BildFormImpl#getAngle <em>Angle</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.impl.BildFormImpl#getZoomVerhalten <em>Zoom Verhalten</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.impl.BildFormImpl#getBild <em>Bild</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class BildFormImpl extends NamedImpl implements BildForm {
	/**
	 * The default value of the '{@link #getLocation() <em>Location</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getLocation()
	 * @generated
	 * @ordered
	 */
	protected static final Point LOCATION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getLocation() <em>Location</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getLocation()
	 * @generated
	 * @ordered
	 */
	protected Point location = LOCATION_EDEFAULT;

	/**
	 * The default value of the '{@link #isVisible() <em>Visible</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #isVisible()
	 * @generated
	 * @ordered
	 */
	protected static final boolean VISIBLE_EDEFAULT = true;

	/**
	 * The cached value of the '{@link #isVisible() <em>Visible</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #isVisible()
	 * @generated
	 * @ordered
	 */
	protected boolean visible = VISIBLE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getDecorators() <em>Decorators</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getDecorators()
	 * @generated
	 * @ordered
	 */
	protected EList<Decorator> decorators;

	/**
	 * The default value of the '{@link #getAngle() <em>Angle</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getAngle()
	 * @generated
	 * @ordered
	 */
	protected static final double ANGLE_EDEFAULT = 0.0;

	/**
	 * The cached value of the '{@link #getAngle() <em>Angle</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getAngle()
	 * @generated
	 * @ordered
	 */
	protected double angle = ANGLE_EDEFAULT;

	/**
	 * The default value of the '{@link #getZoomVerhalten() <em>Zoom Verhalten</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getZoomVerhalten()
	 * @generated
	 * @ordered
	 */
	protected static final ZoomVerhalten ZOOM_VERHALTEN_EDEFAULT = ZoomVerhalten.DYNAMISCH;

	/**
	 * The cached value of the '{@link #getZoomVerhalten() <em>Zoom Verhalten</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getZoomVerhalten()
	 * @generated
	 * @ordered
	 */
	protected ZoomVerhalten zoomVerhalten = ZOOM_VERHALTEN_EDEFAULT;

	/**
	 * The default value of the '{@link #getBild() <em>Bild</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getBild()
	 * @generated
	 * @ordered
	 */
	protected static final Bild BILD_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getBild() <em>Bild</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getBild()
	 * @generated
	 * @ordered
	 */
	protected Bild bild = BILD_EDEFAULT;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected BildFormImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return DoeditorPackage.Literals.BILD_FORM;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Point getLocation() {
		return location;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setLocation(Point newLocation) {
		Point oldLocation = location;
		location = newLocation;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					DoeditorPackage.BILD_FORM__LOCATION, oldLocation, location));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EditorDoTyp getEditorDoTyp() {
		if (eContainerFeatureID() != DoeditorPackage.BILD_FORM__EDITOR_DO_TYP)
			return null;
		return (EditorDoTyp) eContainer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetEditorDoTyp(EditorDoTyp newEditorDoTyp,
			NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newEditorDoTyp,
				DoeditorPackage.BILD_FORM__EDITOR_DO_TYP, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setEditorDoTyp(EditorDoTyp newEditorDoTyp) {
		if (newEditorDoTyp != eInternalContainer()
				|| (eContainerFeatureID() != DoeditorPackage.BILD_FORM__EDITOR_DO_TYP && newEditorDoTyp != null)) {
			if (EcoreUtil.isAncestor(this, newEditorDoTyp))
				throw new IllegalArgumentException(
						"Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newEditorDoTyp != null)
				msgs = ((InternalEObject) newEditorDoTyp).eInverseAdd(this,
						DoeditorPackage.EDITOR_DO_TYP__FORMEN,
						EditorDoTyp.class, msgs);
			msgs = basicSetEditorDoTyp(newEditorDoTyp, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					DoeditorPackage.BILD_FORM__EDITOR_DO_TYP, newEditorDoTyp,
					newEditorDoTyp));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isVisible() {
		return visible;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setVisible(boolean newVisible) {
		boolean oldVisible = visible;
		visible = newVisible;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					DoeditorPackage.BILD_FORM__VISIBLE, oldVisible, visible));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<Decorator> getDecorators() {
		if (decorators == null) {
			decorators = new EObjectContainmentEList<Decorator>(
					Decorator.class, this,
					DoeditorPackage.BILD_FORM__DECORATORS);
		}
		return decorators;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public double getAngle() {
		return angle;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setAngle(double newAngle) {
		double oldAngle = angle;
		angle = newAngle;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					DoeditorPackage.BILD_FORM__ANGLE, oldAngle, angle));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ZoomVerhalten getZoomVerhalten() {
		return zoomVerhalten;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setZoomVerhalten(ZoomVerhalten newZoomVerhalten) {
		ZoomVerhalten oldZoomVerhalten = zoomVerhalten;
		zoomVerhalten = newZoomVerhalten == null ? ZOOM_VERHALTEN_EDEFAULT
				: newZoomVerhalten;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					DoeditorPackage.BILD_FORM__ZOOM_VERHALTEN,
					oldZoomVerhalten, zoomVerhalten));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public Rectangle getBounds() {
		// TODO: Bildgroesse ermitteln
		return new Rectangle(getLocation(), new Dimension(50, 50));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public void setBounds(final Rectangle newBounds) {
		setLocation(newBounds.getLocation());
		// TODO: Gre bercksichtigen
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Bild getBild() {
		return bild;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setBild(Bild newBild) {
		Bild oldBild = bild;
		bild = newBild;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					DoeditorPackage.BILD_FORM__BILD, oldBild, bild));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case DoeditorPackage.BILD_FORM__EDITOR_DO_TYP:
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			return basicSetEditorDoTyp((EditorDoTyp) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case DoeditorPackage.BILD_FORM__EDITOR_DO_TYP:
			return basicSetEditorDoTyp(null, msgs);
		case DoeditorPackage.BILD_FORM__DECORATORS:
			return ((InternalEList<?>) getDecorators()).basicRemove(otherEnd,
					msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(
			NotificationChain msgs) {
		switch (eContainerFeatureID()) {
		case DoeditorPackage.BILD_FORM__EDITOR_DO_TYP:
			return eInternalContainer().eInverseRemove(this,
					DoeditorPackage.EDITOR_DO_TYP__FORMEN, EditorDoTyp.class,
					msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case DoeditorPackage.BILD_FORM__LOCATION:
			return getLocation();
		case DoeditorPackage.BILD_FORM__EDITOR_DO_TYP:
			return getEditorDoTyp();
		case DoeditorPackage.BILD_FORM__VISIBLE:
			return isVisible();
		case DoeditorPackage.BILD_FORM__DECORATORS:
			return getDecorators();
		case DoeditorPackage.BILD_FORM__ANGLE:
			return getAngle();
		case DoeditorPackage.BILD_FORM__ZOOM_VERHALTEN:
			return getZoomVerhalten();
		case DoeditorPackage.BILD_FORM__BILD:
			return getBild();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case DoeditorPackage.BILD_FORM__LOCATION:
			setLocation((Point) newValue);
			return;
		case DoeditorPackage.BILD_FORM__EDITOR_DO_TYP:
			setEditorDoTyp((EditorDoTyp) newValue);
			return;
		case DoeditorPackage.BILD_FORM__VISIBLE:
			setVisible((Boolean) newValue);
			return;
		case DoeditorPackage.BILD_FORM__DECORATORS:
			getDecorators().clear();
			getDecorators().addAll((Collection<? extends Decorator>) newValue);
			return;
		case DoeditorPackage.BILD_FORM__ANGLE:
			setAngle((Double) newValue);
			return;
		case DoeditorPackage.BILD_FORM__ZOOM_VERHALTEN:
			setZoomVerhalten((ZoomVerhalten) newValue);
			return;
		case DoeditorPackage.BILD_FORM__BILD:
			setBild((Bild) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case DoeditorPackage.BILD_FORM__LOCATION:
			setLocation(LOCATION_EDEFAULT);
			return;
		case DoeditorPackage.BILD_FORM__EDITOR_DO_TYP:
			setEditorDoTyp((EditorDoTyp) null);
			return;
		case DoeditorPackage.BILD_FORM__VISIBLE:
			setVisible(VISIBLE_EDEFAULT);
			return;
		case DoeditorPackage.BILD_FORM__DECORATORS:
			getDecorators().clear();
			return;
		case DoeditorPackage.BILD_FORM__ANGLE:
			setAngle(ANGLE_EDEFAULT);
			return;
		case DoeditorPackage.BILD_FORM__ZOOM_VERHALTEN:
			setZoomVerhalten(ZOOM_VERHALTEN_EDEFAULT);
			return;
		case DoeditorPackage.BILD_FORM__BILD:
			setBild(BILD_EDEFAULT);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case DoeditorPackage.BILD_FORM__LOCATION:
			return LOCATION_EDEFAULT == null ? location != null
					: !LOCATION_EDEFAULT.equals(location);
		case DoeditorPackage.BILD_FORM__EDITOR_DO_TYP:
			return getEditorDoTyp() != null;
		case DoeditorPackage.BILD_FORM__VISIBLE:
			return visible != VISIBLE_EDEFAULT;
		case DoeditorPackage.BILD_FORM__DECORATORS:
			return decorators != null && !decorators.isEmpty();
		case DoeditorPackage.BILD_FORM__ANGLE:
			return angle != ANGLE_EDEFAULT;
		case DoeditorPackage.BILD_FORM__ZOOM_VERHALTEN:
			return zoomVerhalten != ZOOM_VERHALTEN_EDEFAULT;
		case DoeditorPackage.BILD_FORM__BILD:
			return BILD_EDEFAULT == null ? bild != null : !BILD_EDEFAULT
					.equals(bild);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == Located.class) {
			switch (derivedFeatureID) {
			case DoeditorPackage.BILD_FORM__LOCATION:
				return GefPackage.LOCATED__LOCATION;
			default:
				return -1;
			}
		}
		if (baseClass == ZoomableForm.class) {
			switch (derivedFeatureID) {
			case DoeditorPackage.BILD_FORM__ZOOM_VERHALTEN:
				return DoeditorPackage.ZOOMABLE_FORM__ZOOM_VERHALTEN;
			default:
				return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == Located.class) {
			switch (baseFeatureID) {
			case GefPackage.LOCATED__LOCATION:
				return DoeditorPackage.BILD_FORM__LOCATION;
			default:
				return -1;
			}
		}
		if (baseClass == ZoomableForm.class) {
			switch (baseFeatureID) {
			case DoeditorPackage.ZOOMABLE_FORM__ZOOM_VERHALTEN:
				return DoeditorPackage.BILD_FORM__ZOOM_VERHALTEN;
			default:
				return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (location: ");
		result.append(location);
		result.append(", visible: ");
		result.append(visible);
		result.append(", angle: ");
		result.append(angle);
		result.append(", zoomVerhalten: ");
		result.append(zoomVerhalten);
		result.append(", bild: ");
		result.append(bild);
		result.append(')');
		return result.toString();
	}

} // BildFormImpl
